
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>6.8. [U4.31.02] : Operator DEFI_FONCTION (DEFINE_FUNCTION) &#8212; Code-Aster v14 0.1 documentation</title>
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/app.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="../../_static/graphviz.css" />
    <link rel="stylesheet" type="text/css" href="../../_static/code_aster.css" />
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="6.9. [U4.34.01] : Operator DEFI_LIST_REEL (DEFINE_LIST_OF_REALS)" href="u4.34.01.html" />
    <link rel="prev" title="6.7. [U4.26.01] : Operator DEFI_GEOM_FIBRE" href="u4.26.01.html" />

<script type="text/javascript" src="../../_static/sidebar.js"></script>

<link rel="stylesheet" href="https://use.typekit.net/isi7ftn.css">
<script>try{Typekit.load({ async: true });}catch(e){}</script>
<script type="text/javascript" src="../../_static/copybutton.js"></script>


  </head><body>
<div class="topbar">
  <!--
  <a class="brand" title="Documentation Home" href="../../index.html">
    <span id="logotext">LSST Science Pipelines</span>
  </a>
  -->
  <ul>
    <li><a href="https://www.code-aster.org/V2/spip.php?rubrique19">Code Aster PDF Docs</a></li>
  </ul>
</div>

<div class="related">
    <h3>Navigation</h3>
    <ul>
      <li class="right">
	<a href="u4.34.01.html" title="6.9. [U4.34.01] : Operator DEFI_LIST_REEL (DEFINE_LIST_OF_REALS)">
	  next &raquo;
	</a>
      </li>
      <li class="right">
	<a href="u4.26.01.html" title="6.7. [U4.26.01] : Operator DEFI_GEOM_FIBRE">
	  &laquo; previous
	</a>
	 |
      </li>
      <li>
	<a href="../../index.html">Code-Aster v14 0.1 documentation</a>
	 &#187;
      </li>
      <li><a href="u4_toc.html" accesskey="U"><span class="section-number">6. </span><strong>U4</strong>: Command documentation</a> &#187;</li>
      
      <li><span class="section-number">6.8. </span><strong>[U4.31.02]</strong> : Operator <code class="docutils literal notranslate"><span class="pre">DEFI_FONCTION</span></code> (<span class="gray">DEFINE_FUNCTION</span>)</li> 
    </ul>
</div>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="u4-31-02-operator-defi-fonction-define-function">
<span id="u4-31-02"></span><span id="index-0"></span><h1><span class="section-number">6.8. </span><strong>[U4.31.02]</strong> : Operator <code class="docutils literal notranslate"><span class="pre">DEFI_FONCTION</span></code> (<span class="gray">DEFINE_FUNCTION</span>)<a class="headerlink" href="#u4-31-02-operator-defi-fonction-define-function" title="Permalink to this headline">¶</a></h1>
<div class="section" id="purpose">
<span id="u4-31-02-1"></span><h2><span class="section-number">6.8.1. </span>Purpose<a class="headerlink" href="#purpose" title="Permalink to this headline">¶</a></h2>
<p>Define a real or complex function of a real variable. This operator is used to define, for example,
material properties that are functions of the temperature, or boundary conditions which depend on a
space or time variable.</p>
<p>The concept output by this operator is of type <span class="green">fonction</span>.</p>
</div>
<div class="section" id="syntax">
<span id="u4-31-02-2"></span><h2><span class="section-number">6.8.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>func [fonction] = DEFI_FONCTION
(
 ♦ NOM_PARA = np,
 ◊ NOM_RESU = / &#39;TOUTRESU&#39;,                          [DEFAULT]
              / nr,                                  [K8]
 ♦ / VALE = l_val_r,                                 [l_R]
   / VALE_C = l_val_c,                               [l_C]
   / VALE_PARA = l_para,                             [listr8]
     ♦ VALE_FONC = l_func,                           [listr8]
   / ABSCISSE = l_x_vals,                            [l_R]
     ♦ ORDONNEE = l_y_vals,                          [l_R]
   / NOEUD_PARA = l_node,                            [l_noeud]
     ♦ MAILLAGE = mesh,                              [maillage]
     ♦ VALE_Y = l_y,                                 [l_R]
 ◊ PROL_DROITE = / &#39;CONSTANT&#39;,
                 / &#39;LINEAIRE&#39;,
                 / &#39;EXCLU&#39;,                          [DEFAULT]
 ◊ PROL_GAUCHE = / &#39;CONSTANT&#39;,
                 / &#39;LINEAIRE&#39;,
                 / &#39;EXCLU&#39;,                          [DEFAULT]
 ◊ INTERPOL = | &#39;LIN&#39;,                               [DEFAULT]
              | &#39;LOG&#39;,
 ◊ INFO = / 1,                                       [DEFAULT]
          / 2,
 ◊ VERIF = | &#39;CROISSANT&#39;,                            [DEFAULT]
           | &#39;NON&#39;,
 ◊ TITRE = title,                                    [l_Kn]
)
</pre></div>
</div>
</div>
<div class="section" id="operands">
<span id="u4-31-02-3"></span><h2><span class="section-number">6.8.3. </span>Operands<a class="headerlink" href="#operands" title="Permalink to this headline">¶</a></h2>
<div class="section" id="operand-nom-para-parameter-name">
<span id="u4-31-02-3-1"></span><h3><span class="section-number">6.8.3.1. </span>Operand <span class="blue">NOM_PARA</span> (<span class="gray">PARAMETER_NAME</span>)<a class="headerlink" href="#operand-nom-para-parameter-name" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ NOM_PARA = np
</pre></div>
</div>
<p>Designates the name of the parameter (independent variable or abscissa) of the function. The
possible values for <span class="green">np</span> are:</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 27%" />
<col style="width: 73%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>Parameter name</p></th>
<th class="head"><p>Meaning</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><span class="green">‘ABSC’</span></p></td>
<td><p>Curvilinear abscissa (arc-length coordinates)</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘AMOR’</span></p></td>
<td><p>Damping</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘DRX’</span></p></td>
<td><p>Rotation around the <span class="math notranslate nohighlight">\(x\)</span> axis</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘DRY’</span></p></td>
<td><p>Rotation around the <span class="math notranslate nohighlight">\(y\)</span> axis</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘DRZ’</span></p></td>
<td><p>Rotation around the <span class="math notranslate nohighlight">\(z\)</span> axis</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘DSP’</span></p></td>
<td></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘DX’</span></p></td>
<td><p>Displacement along the <span class="math notranslate nohighlight">\(x\)</span> axis</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘DY’</span></p></td>
<td><p>Displacement along the <span class="math notranslate nohighlight">\(y\)</span> axis</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘DZ’</span></p></td>
<td><p>Displacement along the <span class="math notranslate nohighlight">\(z\)</span> axis</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘ENDO’</span></p></td>
<td><p>Damage</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘EPAIS’</span></p></td>
<td><p>Thickness</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘EPSI’</span></p></td>
<td><p>Strain</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘FREQ’</span></p></td>
<td><p>Frequency</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘HYDR’</span></p></td>
<td><p>Hydration</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘INST’</span></p></td>
<td><p>Time instant</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘META’</span></p></td>
<td></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘NEUT1’</span></p></td>
<td><p>Neutral parameter 1</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘NEUT2’</span></p></td>
<td><p>Neutral parameter 2</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘NORM’</span></p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘NUME_ORDRE’</span></p></td>
<td><p>Time step sequence number</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘PAD’</span></p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘PCAP’</span></p></td>
<td><p>Capillary pressure</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘PGAZ’</span></p></td>
<td><p>Gas pressure</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘PLIQ’</span></p></td>
<td><p>Liquid pressure</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘PORO’</span></p></td>
<td><p>Porosity</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘PULS’</span></p></td>
<td><p>Wave amplitude</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘PVAP’</span></p></td>
<td><p>Vapor pressure</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘SAT’</span></p></td>
<td><p>Saturation</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘SECH’</span></p></td>
<td><p>Dessication</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘SIGM’</span></p></td>
<td><p>Stress</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘TEMP’</span></p></td>
<td><p>Temperature</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘TSEC’</span></p></td>
<td></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘VITE’</span></p></td>
<td><p>Velocity</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘X’</span></p></td>
<td><p><span class="math notranslate nohighlight">\(x\)</span> coordinate</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘Y’</span></p></td>
<td><p><span class="math notranslate nohighlight">\(y\)</span> coordinate</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘Z’</span></p></td>
<td><p><span class="math notranslate nohighlight">\(z\)</span> coordinate</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘XF’</span></p></td>
<td><p>Final <span class="math notranslate nohighlight">\(x\)</span> coordinate (in the case of follower loading)</p></td>
</tr>
<tr class="row-odd"><td><p><span class="green">‘YF’</span></p></td>
<td><p>Final <span class="math notranslate nohighlight">\(y\)</span> coordinate (in the case of follower loading)</p></td>
</tr>
<tr class="row-even"><td><p><span class="green">‘ZF’</span></p></td>
<td><p>Final <span class="math notranslate nohighlight">\(z\)</span> coordinate (in the case of follower loading)</p></td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="operand-nom-resu-result-name">
<span id="u4-31-02-3-2"></span><h3><span class="section-number">6.8.3.2. </span>Operand <span class="blue">NOM_RESU</span> (<span class="gray">RESULT_NAME</span>)<a class="headerlink" href="#operand-nom-resu-result-name" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ NOM_RESU = nr
</pre></div>
</div>
<p>Designates the name of the result (8 characters). The function thus created is
<span class="green">nr = f(np)</span>.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Certain commands (<span class="red">CALC_FONCTION</span>, <span class="red">DEFI_MATERIAU</span>, …) check the consistency of
parameter name and the result according to the context. For example, we expect a stress-strain
curve defined by a function whose <span class="blue">NOM_PARA = ‘EPSI’</span> and <span class="blue">NOM_RESU = ‘SIGM’</span>.</p>
</div>
</div>
<div class="section" id="operand-vale-value">
<span id="u4-31-02-3-3"></span><h3><span class="section-number">6.8.3.3. </span>Operand <span class="blue">VALE</span> (<span class="gray">VALUE</span>)<a class="headerlink" href="#operand-vale-value" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">/</span> <span class="n">VALE</span> <span class="o">=</span> <span class="n">l_val_r</span>
</pre></div>
</div>
<p><span class="green">l_val_r</span> is the list of values <span class="math notranslate nohighlight">\((x_1, y_1, \dots, x_n, y_n)\)</span> input in a specific
order:</p>
<ul class="simple">
<li><p><span class="math notranslate nohighlight">\(x_1, y_1\)</span> (the first value of the parameter and the corresponding value of the result),</p></li>
<li><p>…,</p></li>
<li><p><span class="math notranslate nohighlight">\(x_n, y_n\)</span> (the last value of the parameter and the corresponding value of the result).</p></li>
</ul>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The list <span class="green">l_val_r</span> of values must be described in the order of the ascending abscissa
(<span class="math notranslate nohighlight">\(x\)</span>).</p>
</div>
</div>
<div class="section" id="operand-vale-c-value-complex">
<span id="u4-31-02-3-4"></span><h3><span class="section-number">6.8.3.4. </span>Operand <span class="blue">VALE_C</span> (<span class="gray">VALUE_COMPLEX</span>)<a class="headerlink" href="#operand-vale-c-value-complex" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">/</span> <span class="n">VALE_C</span> <span class="o">=</span> <span class="n">l_val_c</span>
</pre></div>
</div>
<p><span class="green">l_val_c</span> is the list of values <span class="math notranslate nohighlight">\((x_1, y_1, z_1, \dots, x_n, y_n, z_n)\)</span> where:</p>
<ul class="simple">
<li><p><span class="math notranslate nohighlight">\(x_i\)</span> are the values of the parameter (independent variable)</p></li>
<li><p><span class="math notranslate nohighlight">\(y_i, z_i\)</span> are the real part and the imaginary part of the complex function of this parameter.</p></li>
</ul>
</div>
<div class="section" id="operands-abscisse-ordonnee-abscissa-ordinate">
<span id="u4-31-02-3-5"></span><h3><span class="section-number">6.8.3.5. </span>Operands <span class="blue">ABSCISSE / ORDONNEE</span> (<span class="gray">ABSCISSA/ORDINATE</span>)<a class="headerlink" href="#operands-abscisse-ordonnee-abscissa-ordinate" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">/</span> <span class="n">ABSCISSE</span> <span class="o">=</span> <span class="n">l_x_vals</span>
<span class="o">/</span> <span class="n">ORDONNEE</span> <span class="o">=</span> <span class="n">l_y_vals</span>
</pre></div>
</div>
<p>We provide the values of the <span class="math notranslate nohighlight">\(x\)</span>-coordinates and <span class="math notranslate nohighlight">\(y\)</span>-coordinates of the function
separately in the form of lists of real values <span class="math notranslate nohighlight">\((x_1, x_2, \dots, x_n)\)</span> for <span class="blue">ABSCISSE</span>
and <span class="math notranslate nohighlight">\((y_1, y_2, \dots, y_n)\)</span> for <span class="blue">ORDONNEE</span>. The two lists must have the same number
of elements.</p>
</div>
<div class="section" id="operand-vale-para-vale-fonc-value-indep-var-value-dep-func">
<span id="u4-31-02-3-6"></span><h3><span class="section-number">6.8.3.6. </span>Operand <span class="blue">VALE_PARA / VALE_FONC</span> (<span class="gray">VALUE_INDEP_VAR, VALUE_DEP_FUNC</span>)<a class="headerlink" href="#operand-vale-para-vale-fonc-value-indep-var-value-dep-func" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">/</span> <span class="n">VALE_PARA</span> <span class="o">=</span> <span class="n">l_para</span>
<span class="o">/</span> <span class="n">VALE_FONC</span> <span class="o">=</span> <span class="n">l_func</span>
</pre></div>
</div>
<p>Same operation as <span class="blue">ABSCISSE, ORDONNEE</span> except that the lists are provided in the form of
concepts of type <span class="green">listr8</span> produced by <span class="red">DEFI_LIST_REEL</span> <a class="reference internal" href="u4.34.01.html#u4-34-01"><span class="std std-ref">[U4.34.01]</span></a>.</p>
<p><span class="blue">VALE_PARA</span> and <span class="blue">VALE_FONC</span> must have identical cardinal numbers (same number of
entries). If not, the command stops with a fault.</p>
</div>
<div class="section" id="operand-noeud-para-nodes-indep-var">
<span id="u4-31-02-3-7"></span><h3><span class="section-number">6.8.3.7. </span>Operand <span class="blue">NOEUD_PARA</span> (<span class="gray">NODES_INDEP_VAR</span>)<a class="headerlink" href="#operand-noeud-para-nodes-indep-var" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">/</span> <span class="n">NODE_PARA</span> <span class="o">=</span> <span class="n">l_node</span>
</pre></div>
</div>
<p><span class="green">l_node</span> is the list of nodes used to define the values of the <span class="math notranslate nohighlight">\(x\)</span>-coordinates of
the function to be defined. The abscissas will be equal to the curvilinear abscissas (arc-length
coordinates) of the nodes on the curve which they define.</p>
</div>
<div class="section" id="operands-prol-droite-and-prol-gauche-extrapolation">
<span id="u4-31-02-3-8"></span><h3><span class="section-number">6.8.3.8. </span>Operands <span class="blue">PROL_DROITE</span> and <span class="blue">PROL_GAUCHE</span> (<span class="gray">EXTRAPOLATION</span>)<a class="headerlink" href="#operands-prol-droite-and-prol-gauche-extrapolation" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ PROL_DROITE =
◊ PROL_GAUCHE =
</pre></div>
</div>
<p>Define the type of extrapolation to the right (to the left) of the domain on which the variable is
defined:</p>
<ul class="simple">
<li><p><span class="blue">‘CONSTANT’</span> : for an extrapolation that uses the last (or first) value of the function,</p></li>
<li><p><span class="blue">‘LINEAIRE’</span> : for an extrapolation along the first defined segment (<span class="blue">PROL_GAUCHE</span>)
or the last defined segment (<span class="blue">PROL_DROITE</span>),</p></li>
<li><p><span class="blue">‘EXCLU’</span> : if the extrapolation of values outside the domain of definition of parameter is
prohibited (in this case if a calculation requires a value of the function outside the definition
domain, the code will stop with a fatal error).</p></li>
</ul>
<p>For example :</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">PROL_DROITE</span> <span class="o">=</span> <span class="s1">&#39;CONSTANT&#39;</span><span class="p">,</span>
<span class="n">PROL_GAUCHE</span> <span class="o">=</span> <span class="s1">&#39;CONSTANT&#39;</span>
</pre></div>
</div>
<div class="figure align-center">
<a class="reference internal image-reference" href="../../_images/fig1_u4.31.02.png"><img alt="../../_images/fig1_u4.31.02.png" src="../../_images/fig1_u4.31.02.png" style="height: 250px;" /></a>
</div>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">PROL_DROITE</span> <span class="o">=</span> <span class="s1">&#39;LINEAIRE&#39;</span><span class="p">,</span>
<span class="n">PROL_GAUCHE</span> <span class="o">=</span> <span class="s1">&#39;EXCLU&#39;</span>
</pre></div>
</div>
<div class="figure align-center">
<a class="reference internal image-reference" href="../../_images/fig2_u4.31.02.png"><img alt="../../_images/fig2_u4.31.02.png" src="../../_images/fig2_u4.31.02.png" style="height: 250px;" /></a>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The extrapolation and interpolation methods are independent of each other.</p>
</div>
</div>
<div class="section" id="operand-interpol-interpolation">
<span id="u4-31-02-3-9"></span><h3><span class="section-number">6.8.3.9. </span>Operand <span class="blue">INTERPOL</span> (<span class="gray">INTERPOLATION</span>)<a class="headerlink" href="#operand-interpol-interpolation" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ INTERPOL =
</pre></div>
</div>
<p>Type of interpolation of the function between the values of the domain of definition of the function:
one type for the interpolation of the parameter and one for the interpolation of the function. This
is obtained by providing a list of strings such as:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">INTERPOL</span> <span class="o">=</span> <span class="p">(</span><span class="s1">&#39;LIN&#39;</span><span class="p">,</span> <span class="s1">&#39;LOG&#39;</span><span class="p">)</span>
</pre></div>
</div>
<ul class="simple">
<li><p><span class="blue">‘LIN’</span>: linear,</p></li>
<li><p><span class="blue">‘LOG’</span>: logarithmic.</p></li>
</ul>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>If only one value is specified, it is taken into account at the same time by the interpolation
of the parameter and function. <span class="blue">INTERPOL = ‘LOG’</span> is equivalent to <span class="blue">(‘LOG’, ‘LOG’)</span>.</p>
</div>
</div>
<div class="section" id="operand-info">
<span id="u4-31-02-3-10"></span><h3><span class="section-number">6.8.3.10. </span>Operand <span class="blue">INFO</span><a class="headerlink" href="#operand-info" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ INFO =
</pre></div>
</div>
<p>Specifies the output options printed to the MESSAGE file.</p>
<ul class="simple">
<li><p>1: no printing (default option)</p></li>
<li><p>2: printing of the parameters plus the list of the first 10 values in ascending order
of the parameter</p></li>
</ul>
</div>
<div class="section" id="operand-verif">
<span id="u4-31-02-3-11"></span><h3><span class="section-number">6.8.3.11. </span>Operand <span class="blue">VERIF</span><a class="headerlink" href="#operand-verif" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ VERIF =
</pre></div>
</div>
<p>The operator <span class="red">DEFI_FONCTION</span> checks that the values of the abscissas are strictly increasing. If
this is not true, an error is raised. This is the default behavior, <span class="blue">VERIF = ‘CROISSANT’</span>.</p>
<p>The user has the possibility of not doing this check by indicating <span class="blue">VERIF = ‘NON’</span>. In that
case, the function is reordered by increasing abscissa. An alarm is issued if the abscissas of the
function were not increasing. On the other hand, the abscissas must imperatively be strictly monotonic.</p>
</div>
<div class="section" id="operand-titre-title">
<span id="u4-31-02-3-12"></span><h3><span class="section-number">6.8.3.12. </span>Operand <span class="blue">TITRE</span> (<span class="gray">TITLE</span>)<a class="headerlink" href="#operand-titre-title" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ TITRE = title
</pre></div>
</div>
<p>Title attached to the concept produced by this operator <span class="xref std std-ref">[U4.03.01]</span>.</p>
</div>
<div class="section" id="operands-maillage-mesh-and-vale-y-y-value">
<span id="u4-31-02-3-13"></span><h3><span class="section-number">6.8.3.13. </span>Operands <span class="blue">MAILLAGE</span> (<span class="gray">MESH</span>) and <span class="blue">VALE_Y</span> (<span class="gray">Y_VALUE</span>)<a class="headerlink" href="#operands-maillage-mesh-and-vale-y-y-value" title="Permalink to this headline">¶</a></h3>
<p>It is necessary to include these two keywords if one defines the function starting from
<span class="blue">NOEUD_PARA</span> (see <a class="reference internal" href="#u4-31-02-3-7"><span class="std std-numref">Section 6.8.3.7</span></a>):</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">MAILLAGE</span> <span class="o">=</span> <span class="n">mesh</span>
</pre></div>
</div>
<p>Name of the mesh associated with the list of nodes <span class="green">l_node</span>.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">VALE_Y</span> <span class="o">=</span> <span class="n">l_val_y</span>
</pre></div>
</div>
<p>List of the values of the ordinates of the function to be defined.</p>
</div>
</div>
<div class="section" id="definition-of-a-time-dependent-function">
<span id="u4-31-02-4"></span><h2><span class="section-number">6.8.4. </span>Definition of a time dependent function<a class="headerlink" href="#definition-of-a-time-dependent-function" title="Permalink to this headline">¶</a></h2>
<div class="section" id="function-and-variables-are-entered-as-reals">
<span id="u4-31-02-4-1"></span><h3><span class="section-number">6.8.4.1. </span>Function and variables are entered as reals<a class="headerlink" href="#function-and-variables-are-entered-as-reals" title="Permalink to this headline">¶</a></h3>
<p>Definition of a function (piecewise linear) depends on time (parameter <span class="green">INST</span>)</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">f_ex1</span> <span class="o">=</span> <span class="n">DEFI_FONCTION</span><span class="p">(</span><span class="n">NOM_PARA</span> <span class="o">=</span> <span class="s1">&#39;INST&#39;</span><span class="p">,</span>
                      <span class="n">VALE</span> <span class="o">=</span> <span class="p">(</span><span class="mf">0.</span><span class="p">,</span> <span class="o">-</span><span class="mf">1.</span><span class="p">,</span>
                              <span class="mf">1.</span><span class="p">,</span>  <span class="mf">0.</span><span class="p">,</span>
                              <span class="mf">3.</span><span class="p">,</span>  <span class="mf">1.</span><span class="p">,</span>
                              <span class="mf">6.</span><span class="p">,</span>  <span class="mf">2.</span><span class="p">),</span>
                      <span class="n">PROL_GAUCHE</span> <span class="o">=</span> <span class="s1">&#39;CONSTANT&#39;</span><span class="p">,</span>
                      <span class="n">PROL_DROITE</span> <span class="o">=</span> <span class="s1">&#39;LINEAIRE&#39;</span><span class="p">)</span>
</pre></div>
</div>
<div class="figure align-center">
<a class="reference internal image-reference" href="../../_images/fig3_u4.31.02.png"><img alt="../../_images/fig3_u4.31.02.png" src="../../_images/fig3_u4.31.02.png" style="height: 250px;" /></a>
</div>
</div>
<div class="section" id="function-and-variables-entered-as-listr8-concepts">
<span id="u4-31-02-4-2"></span><h3><span class="section-number">6.8.4.2. </span>Function and variables entered as <span class="green">listr8</span> concepts<a class="headerlink" href="#function-and-variables-entered-as-listr8-concepts" title="Permalink to this headline">¶</a></h3>
<p>It is possible to define this function using concepts of type <span class="green">listr8</span> created via operator
<span class="red">DEFI_LIST_REEL</span> <a class="reference internal" href="u4.34.01.html#u4-34-01"><span class="std std-ref">[U4.34.01]</span></a>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">x_vals</span> <span class="o">=</span> <span class="n">DEFI_LIST_REEL</span><span class="p">(</span><span class="n">DEBUT</span> <span class="o">=</span> <span class="mf">0.</span><span class="p">,</span>
                        <span class="n">INTERVALLE</span> <span class="o">=</span> <span class="p">(</span><span class="n">_F</span><span class="p">(</span><span class="n">JUSQU_A</span> <span class="o">=</span> <span class="mf">1.</span><span class="p">,</span>
                                         <span class="n">NOMBRE</span> <span class="o">=</span> <span class="mi">1</span><span class="p">),</span>
                                      <span class="n">_F</span><span class="p">(</span><span class="n">JUSQU_A</span> <span class="o">=</span> <span class="mf">3.</span><span class="p">,</span>
                                         <span class="n">NOMBRE</span> <span class="o">=</span> <span class="mi">1</span><span class="p">),</span>
                                      <span class="n">_F</span><span class="p">(</span><span class="n">JUSQU_A</span> <span class="o">=</span> <span class="mf">6.</span><span class="p">,</span>
                                         <span class="n">NOMBRE</span> <span class="o">=</span> <span class="mi">1</span><span class="p">)))</span>

<span class="n">y_vals</span> <span class="o">=</span> <span class="n">DEFI_LIST_REEL</span><span class="p">(</span><span class="n">DEBUT</span> <span class="o">=</span> <span class="o">-</span><span class="mf">1.</span><span class="p">,</span>
                        <span class="n">INTERVALLE</span> <span class="o">=</span> <span class="p">(</span><span class="n">_F</span><span class="p">(</span><span class="n">JUSQU_A</span> <span class="o">=</span> <span class="mf">0.</span><span class="p">,</span>
                                         <span class="n">NOMBRE</span> <span class="o">=</span> <span class="mi">1</span><span class="p">),</span>
                                      <span class="n">_F</span><span class="p">(</span><span class="n">JUSQU_A</span> <span class="o">=</span> <span class="mf">1.</span><span class="p">,</span>
                                         <span class="n">NOMBRE</span> <span class="o">=</span> <span class="mi">1</span><span class="p">),</span>
                                      <span class="n">_F</span><span class="p">(</span><span class="n">JUSQU_A</span> <span class="o">=</span> <span class="mf">2.</span><span class="p">,</span>
                                         <span class="n">NOMBRE</span> <span class="o">=</span> <span class="mi">1</span><span class="p">)))</span>

<span class="n">f_ex2</span> <span class="o">=</span> <span class="n">DEFI_FONCTION</span><span class="p">(</span><span class="n">NOM_PARA</span> <span class="o">=</span> <span class="s1">&#39;INST&#39;</span><span class="p">,</span>
                      <span class="n">VALE_PARA</span> <span class="o">=</span> <span class="n">x_vals</span><span class="p">,</span>
                      <span class="n">VALE_FONC</span> <span class="o">=</span> <span class="n">y_vals</span><span class="p">,</span>
                      <span class="n">PROL_RIGHT</span> <span class="o">=</span> <span class="s1">&#39;CONSTANT&#39;</span><span class="p">,</span>
                      <span class="n">PROL_GAUCHE</span> <span class="o">=</span> <span class="s1">&#39;LINEAIRE&#39;</span><span class="p">)</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This example is obviously more complicated than is absolutely necessary to define the proposed
function. We only want to highlight the principle of using the possibility offered.</p>
<p>This becomes interesting when one uses functions defined over a large number of points.</p>
<p>Another reason to use the definition via <span class="red">DEFI_LIST_REEL</span> is when the lists are necessary
as arguments for another operator: (list of times of a time-dependent computation
<span class="red">THER_LINEAIRE</span>, <span class="red">DYNA_LINE_TRAN</span>, …). This approach then avoids duplication
of information.</p>
</div>
</div>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<form action="../../search.html" method="get">
  <input class='c-searchbox' type="text" name="q" placeholder="Search" />
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form><div>
   <h3>Quick search</h3>
   <script async src="https://cse.google.com/cse.js?cx=1913d02e421931d61"></script>
   <div class="gcse-search"></div>
</div><h3>On this page</h3>
<ul>
<li><a class="reference internal" href="#">6.8. <strong>[U4.31.02]</strong> : Operator <code class="docutils literal notranslate"><span class="pre">DEFI_FONCTION</span></code> (<span class="gray">DEFINE_FUNCTION</span>)</a><ul>
<li><a class="reference internal" href="#purpose">6.8.1. Purpose</a></li>
<li><a class="reference internal" href="#syntax">6.8.2. Syntax</a></li>
<li><a class="reference internal" href="#operands">6.8.3. Operands</a><ul>
<li><a class="reference internal" href="#operand-nom-para-parameter-name">6.8.3.1. Operand <span class="blue">NOM_PARA</span> (<span class="gray">PARAMETER_NAME</span>)</a></li>
<li><a class="reference internal" href="#operand-nom-resu-result-name">6.8.3.2. Operand <span class="blue">NOM_RESU</span> (<span class="gray">RESULT_NAME</span>)</a></li>
<li><a class="reference internal" href="#operand-vale-value">6.8.3.3. Operand <span class="blue">VALE</span> (<span class="gray">VALUE</span>)</a></li>
<li><a class="reference internal" href="#operand-vale-c-value-complex">6.8.3.4. Operand <span class="blue">VALE_C</span> (<span class="gray">VALUE_COMPLEX</span>)</a></li>
<li><a class="reference internal" href="#operands-abscisse-ordonnee-abscissa-ordinate">6.8.3.5. Operands <span class="blue">ABSCISSE / ORDONNEE</span> (<span class="gray">ABSCISSA/ORDINATE</span>)</a></li>
<li><a class="reference internal" href="#operand-vale-para-vale-fonc-value-indep-var-value-dep-func">6.8.3.6. Operand <span class="blue">VALE_PARA / VALE_FONC</span> (<span class="gray">VALUE_INDEP_VAR, VALUE_DEP_FUNC</span>)</a></li>
<li><a class="reference internal" href="#operand-noeud-para-nodes-indep-var">6.8.3.7. Operand <span class="blue">NOEUD_PARA</span> (<span class="gray">NODES_INDEP_VAR</span>)</a></li>
<li><a class="reference internal" href="#operands-prol-droite-and-prol-gauche-extrapolation">6.8.3.8. Operands <span class="blue">PROL_DROITE</span> and <span class="blue">PROL_GAUCHE</span> (<span class="gray">EXTRAPOLATION</span>)</a></li>
<li><a class="reference internal" href="#operand-interpol-interpolation">6.8.3.9. Operand <span class="blue">INTERPOL</span> (<span class="gray">INTERPOLATION</span>)</a></li>
<li><a class="reference internal" href="#operand-info">6.8.3.10. Operand <span class="blue">INFO</span></a></li>
<li><a class="reference internal" href="#operand-verif">6.8.3.11. Operand <span class="blue">VERIF</span></a></li>
<li><a class="reference internal" href="#operand-titre-title">6.8.3.12. Operand <span class="blue">TITRE</span> (<span class="gray">TITLE</span>)</a></li>
<li><a class="reference internal" href="#operands-maillage-mesh-and-vale-y-y-value">6.8.3.13. Operands <span class="blue">MAILLAGE</span> (<span class="gray">MESH</span>) and <span class="blue">VALE_Y</span> (<span class="gray">Y_VALUE</span>)</a></li>
</ul>
</li>
<li><a class="reference internal" href="#definition-of-a-time-dependent-function">6.8.4. Definition of a time dependent function</a><ul>
<li><a class="reference internal" href="#function-and-variables-are-entered-as-reals">6.8.4.1. Function and variables are entered as reals</a></li>
<li><a class="reference internal" href="#function-and-variables-entered-as-listr8-concepts">6.8.4.2. Function and variables entered as <span class="green">listr8</span> concepts</a></li>
</ul>
</li>
</ul>
</li>
</ul>


        </div>
      </div>
      <div class="clearer"></div>
    </div>
<footer class="footer">
  <p class="pull-right">
    <a href="../../_sources/docs/user/u4.31.02.rst.txt"
       rel="nofollow">Page Source</a> &nbsp;
    <a href="#">Back to Top</a></p>
  <p>
  </p>
  <p>
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 3.5.1. Page design is based on <a href="https://project.lsst.org">LSST</a> created modifications of Astropy's bootstrap-astropy theme in <a href="https://github.com/astropy/astropy-helpers">astropy-helpers</a>. <br />
  </p>
  <p>
    &copy; Copyright 2021, Biswajit Banerjee.  Original version &copy; Copyright 2019 EDF R&amp;D - Licensed under the terms of the GNU FDL (http://www.gnu.org/copyleft/fdl.html).<br/>
  </p>
</footer>
  </body>
</html>